GetMask:
	LDS		BUF,Bits_Per_Symbol
	SUB		BUF,ACC
	LDI		ACC,$01
GetMaskRep:
	DEC		BUF
	BREQ	GetMaskRet
	LSL		ACC
	RJMP	GetMaskRep
GetMaskRet:
	RET

MaskOR:
	LDS		BUF,CursorLine
	DEC		BUF
	DEC		BUF
	LDI		XH,HIGH(SymbMem)
	LDI		XL,LOW(SymbMem)
	ADD		XL,BUF
	LD		BUF,X
	OR		BUF,ACC
	ST		X,BUF
	RET

MaskAND:
	COM		ACC
	LDS		BUF,CursorLine
	DEC		BUF
	DEC		BUF
	LDI		XH,HIGH(SymbMem)
	LDI		XL,LOW(SymbMem)
	ADD		XL,BUF
	LD		BUF,X
	AND		BUF,ACC
	ST		X,BUF
	RET

GetSymbols:
	PUSH	ACC
	LDS		ACC,Modulation
	CPI		ACC,$02
	BRNE	GS_noBPSK
	POP		ACC
	RCALL	BPSKcode
	RET
GS_noBPSK:
	CPI		ACC,$04
	BRNE	GS_noQPSK
	POP		ACC
	RCALL	QPSKcode
	RET
GS_noQPSK:
	CPI		ACC,$08
	BRNE	GS_no8PSK
	POP		ACC
	RCALL	PSK8code
	RET
GS_no8PSK:
	CPI		ACC,$16
	BRNE	GS_no16QAM
	POP		ACC
	RCALL	QAM16code
	RET
GS_no16QAM:
	CPI		ACC,$32
	BRNE	GS_no32QAM
	POP		ACC
	RCALL	QAM32code
	RET
GS_no32QAM:
	POP		ACC
	RCALL	QAM64code
	RET


set_BPSK:
	LDI		ACC,$02
	STS		Modulation,ACC
	LDI		ACC,$01
	STS		Bits_per_symbol,ACC
	LDI		ACC,$01
	STS		Mask_byte,ACC
;	LDI		ACC,200
;	OUT     OCR0,ACC
	RET
set_QPSK:
	LDI		ACC,$04
	STS		Modulation,ACC
	LDI		ACC,$02
	STS		Bits_per_symbol,ACC
	LDI		ACC,$03
	STS		Mask_byte,ACC
	LDI		ACC,100
	OUT     OCR0,ACC
	RET
set_8PSK:
	LDI		ACC,$08
	STS		Modulation,ACC
	LDI		ACC,$03
	STS		Bits_per_symbol,ACC
	LDI		ACC,$07
	STS		Mask_byte,ACC
	LDI		ACC,66
    OUT     OCR0,ACC
	RET
set_16QAM:
	LDI		ACC,$16
	STS		Modulation,ACC
	LDI		ACC,$04
	STS		Bits_per_symbol,ACC
	LDI		ACC,$0F
	STS		Mask_byte,ACC
	LDI		ACC,50
    OUT     OCR0,ACC
	RET
set_32QAM:
	LDI		ACC,$32
	STS		Modulation,ACC
	LDI		ACC,$05
	STS		Bits_per_symbol,ACC
	LDI		ACC,$1F
	STS		Mask_byte,ACC
	LDI		ACC,40
    OUT     OCR0,ACC
	RET
set_64QAM:
	LDI		ACC,$64
	STS		Modulation,ACC
	LDI		ACC,$06
	STS		Bits_per_symbol,ACC
	LDI		ACC,$3F
	STS		Mask_byte,ACC
	LDI		ACC,33
    OUT     OCR0,ACC
	RET
set_noMOD:
	LDI		ACC,$01
	STS		Modulation,ACC
	LDI		ACC,$06
	STS		Bits_per_symbol,ACC
	LDI		ACC,$3F
	STS		Mask_byte,ACC
	LDI		ACC,33
    OUT     OCR0,ACC
	RET


BPSKcode:
	PUSH	BUF
	LDI		IBUF,127
	CLR		QBUF
	ANDI	ACC,$01
	LDI		BUF,$01
	CP		ACC,BUF
	BREQ	BPC_00
	LDI		QBUF,$FF
BPC_00:
	POP		BUF
	RET


QPSKcode:
	PUSH	ZH
	PUSH	ZL
	LDI		ZH,HIGH(QPSKTable)
	LDI		ZL,LOW(QPSKTable)
	ANDI	ACC,$03
	RJMP	FindMQAM

PSK8code:
	PUSH	ZH
	PUSH	ZL
	LDI		ZH,HIGH(PSK8Table)
	LDI		ZL,LOW(PSK8Table)
	ANDI	ACC,$07
	RJMP	FindMQAM

QAM16code:
	PUSH	ZH
	PUSH	ZL
	LDI		ZH,HIGH(QAM16Table)
	LDI		ZL,LOW(QAM16Table)
	ANDI	ACC,$0F
	RJMP	FindMQAM

QAM32code:
	PUSH	ZH
	PUSH	ZL
	LDI		ZH,HIGH(QAM32Table)
	LDI		ZL,LOW(QAM32Table)
	ANDI	ACC,$1F
	RJMP	FindMQAM

QAM64code:
	PUSH	ZH
	PUSH	ZL
	LDI		ZH,HIGH(QAM64Table)
	LDI		ZL,LOW(QAM64Table)
	ANDI	ACC,$3F
;	RJMP	FindMQAM

FindMQAM:
	CLC
	ROL		ZL
	ROL		ZH
	CLC
	ROL		ACC
	ADD		ZL,ACC
	CLR		ACC
	ADC		ZH,ACC
	LPM		IBUF,Z+
	LPM		QBUF,Z+
	POP		ZL
	POP		ZH
	RET

GetSymbolByte:
	LDS		ACC,Actual_symbol
	LDI		YH,HIGH(SymbMem)
	LDI		YL,LOW(SymbMem)
	ADD		YL,ACC
	LD		ACC,Y
	RET

LeftShift:
	PUSH	BUF
	LDS		BUF2,Bits_per_symbol
	LDI		BUF,8
	SUB		BUF,BUF2
LeftShift_loop:
	CPI		BUF,0
	BREQ	LeftShift_ret
	DEC		BUF
	LSL		ACC
	RJMP	LeftShift_loop
LeftShift_ret:
	POP		BUF
	RET

GenerateSymb:
	LDS		BUF,Bits_per_symbol
GenerateSmb:
	PUSH	BUF
	RCALL	Gener
	POP		BUF
	DEC		BUF
	CPI		BUF,0
	BRNE	GenerateSmb
	RET

Gener:
	LDS		ACC,GenDat1
	LDS		BUF,GenDat2
	CLC
	ROL		ACC
	ROL		BUF
	BRCS	SetReg1_HI
	CLT
	RJMP	BitStore
SetReg1_HI:
	SET
BitStore:
	BLD		ACC,0
	STS		GenDat1,ACC
	STS		GenDat2,BUF

	CLR		BUF

	LDS		ACC,GenDat2
	BST		ACC,3		;x^11
	CLR		ACC
	BLD		ACC,0
	EOR		BUF,ACC

	LDS		ACC,GenDat2
	BST		ACC,1		;x^8
	CLR		ACC
	BLD		ACC,0
	EOR		BUF,ACC

	LDS		ACC,GenDat1
	BST		ACC,5		;x^5
	CLR		ACC
	BLD		ACC,0
	EOR		BUF,ACC

	LDS		ACC,GenDat1
	BST		ACC,2		;x^2
	CLR		ACC
	BLD		ACC,0
	EOR		BUF,ACC

	LDI		ACC,01
	EOR		BUF,ACC

	LDS		ACC,GenDat1

	EOR		ACC,BUF
	STS		GenDat1,ACC

	RET
