
LCDcmd:           ;poslat prikaz
	CBI		LCD_CTRL,LCD_RS
	RJMP	LCDbyte
LCDdata:          ;poslat data
	SBI		LCD_CTRL,LCD_RS
LCDbyte:          ;poslat byte
	OUT		LCD_BUS,ACC
	CBI		LCD_CTRL,LCD_ENA
	PUSH	BUF
	LDI		BUF,0
LCDbcyk:
	DEC		BUF
	BRNE	LCDbcyk
	POP		BUF
	SBI		LCD_CTRL,LCD_ENA
;	LDI		ACC,$FF
;	OUT   	LCD_BUS,BUF
	RET

LCDclrctrl:
	CBI		LCD_CTRL,LCD_RS
	SBI		LCD_CTRL,LCD_ENA
	RCALL	LCDiwait
	RET
	
LCDinit:
	CBI		LCD_CTRL,LCD_RS
	SBI		LCD_CTRL,LCD_ENA
	LDI		ACC,$38    ;8 bitu a 2 radky
	RCALL	LCDcmd
	RCALL	LCDiwait
	LDI		ACC,$0C    ;display ON
	RCALL	LCDcmd
	RCALL	LCDiwait
	LDI		ACC,$06    ;inkrementace adresy po zapisu a kurzorem psat doprava
	RCALL	LCDcmd
	RCALL	LCDclrHW
	RCALL	LCDiwait
	ret

LCDcurON:
	LDI		ACC,$0F    ;display ON
	RCALL	LCDcmd
	RET

LCDcurOFF:
	LDI		ACC,$0C    ;display ON
	RCALL	LCDcmd
	RET

LCDclr:
	LDI		ACC,$0
LCDclr_0:
	PUSH	ACC
	RCALL	LCDline
	RCALL	LCDwrite
	.db		"                ",0,0
	POP		ACC
	INC		ACC
	CPI		ACC,$4
	BRNE	LCDclr_0
	RET


LCDclrHW:         ;smazat LCD hardwarove
	LDI		ACC,$01
	RCALL	LCDcmd
	RJMP	LCDl1

LCDl4:            ;nastavit druhy radek
	LDI		ACC,$50
	RJMP	LCDpos
LCDl3:            ;nastavit druhy radek
	LDI		ACC,$10
	RJMP	LCDpos
LCDl2:            ;nastavit druhy radek
	LDI		ACC,$40
	RJMP	LCDpos
LCDl1:            ;nastavit prvni radek
	LDI		ACC,$00
LCDpos:           ;nasavit pozici 00-0F; 40-4F; 10-1F; 50-5F
	ORI		ACC,$80
	RCALL	LCDcmd
	RET

LCDline:
	STS		Line,ACC
	LDS		BUF,FirstLine
	SUB		ACC,BUF
	SWAP	ACC
	RCALL	LCDpos4
	RET


LCDlineCurPos:
	LDS		ACC,CursorLine
	LDS		BUF,FirstLine
	SUB		ACC,BUF
	SWAP	ACC
	LDS		BUF,CursorPos
	ADD		ACC,BUF
	RCALL	LCDpos4
	RET


LCDpos4:           ;nasavit pozici 00-0F; 10-1F; 20-2F; 30-3F
	PUSH	ACC
	SWAP	ACC
	ANDI	ACC,$03
	CPI		ACC,$01
	BREQ	LCDpos4_40
	CPI		ACC,$02
	BREQ	LCDpos4_10
	CPI		ACC,$03
	BREQ	LCDpos4_50
	POP		ACC
	ANDI	ACC,$0F
LCDpos4_bez:
	ORI		ACC,$80
	RCALL	LCDcmd
	RET
LCDpos4_40:
	POP		ACC
	ANDI	ACC,$0F
	ORI		ACC,$40
	RJMP	LCDpos4_bez
LCDpos4_10:
	POP		ACC
	ANDI	ACC,$0F
	ORI		ACC,$10
	RJMP	LCDpos4_bez
LCDpos4_50:
	POP		ACC
	ANDI	ACC,$0F
	ORI		ACC,$50
	RJMP	LCDpos4_bez





LCDCGRAM0:        ;nasavit pozici na CGRAM
	LDI		ACC,$00
	ORI		ACC,$40
	RCALL	LCDcmd
	RET


LCDwrite8:
	POP		ZH
	POP		ZL
	CLC
	ROL		ZL
	ROL		ZH
	LDI		BUF,9
LCDwrite8_1:
	LPM		ACC,Z+
	DEC		BUF
	BRNE	LCDwrite8_2
	CLC
	ROR		ZH
	ROR		ZL
	IJMP
LCDwrite8_2:
	RCALL	LCDdata
	RJMP	LCDwrite8_1

LCDlinedata:
	PUSH	ACC
	LDS		ACC,Line
	LDS		BUF,FirstLine
	SUB		ACC,BUF
	CPI		ACC,4
	BRSH	LCDld_ret
	POP		ACC
	RJMP	LCDdata
LCDld_ret:
	POP		ACC
	RET


LCDlinewrite:
	POP		ZH
	POP		ZL
	CLC
	ROL		ZL
	ROL		ZH
writeli0:
	LPM		ACC,Z+
	TST		ACC
	BRNE	writeli1
	LPM		ACC,Z+
	CLC
	ROR		ZH
	ROR		ZL
	IJMP
writeli1:
	RCALL	LCDlinedata
	RJMP	writeli0

LCDwrite:
	POP		ZH
	POP		ZL
	CLC
	ROL		ZL
	ROL		ZH
write0:
	LPM		ACC,Z+
	TST		ACC
	BRNE	write1
	LPM		ACC,Z+
	CLC
	ROR		ZH
	ROR		ZL
	IJMP
write1:
	RCALL	LCDdata
	RJMP	write0

LCDlinedec2:
	CLR		BUF
	LDI		BUF2,$10
LLD2_01:
	CPI		ACC,10
	BRSH	LLD2_02
	ADD		ACC,BUF
	RJMP	LCDlinehex2
LLD2_02:
	ADD		BUF,BUF2
	SUBI	ACC,10
	RJMP	LLD2_01


LCDlinehex2:
	PUSH	ACC
	SWAP	ACC
	RCALL	LCDlinehex1
	POP		ACC
LCDlinehex1:
	ANDI    ACC,$0F
	LDI		BUF,48
	ADD		ACC,BUF
	CPI		ACC,58
	BRLO	LCDline_h_2
	LDI		BUF,7
	ADD		ACC,BUF
LCDline_h_2:
	RCALL	LCDlinedata
	RET


;LCDhex2:
	SWAP	ACC
	MOV		BUF,ACC
	RCALL	LCDhex1
	MOV		ACC,BUF
	SWAP	ACC
LCDhex1:
	ANDI    ACC,$0F
	PUSH	BUF
	LDI		BUF,48
	ADD		ACC,BUF
	POP		BUF
	CPI		ACC,58
	BRLO	LCDh_2
	PUSH	BUF
	LDI		BUF,7
	ADD		ACC,BUF
	POP		BUF
LCDh_2:
	RCALL	LCDdata
	RET


LCDlineb:
	CLC
	ROL		ACC
	PUSH	ACC
	ROL		ACC
	ANDI	ACC,$01
	PUSH	BUF
	RCALL	LCDlinehex1
	POP		BUF
	POP		ACC
	DEC		BUF
	BRNE	LCDlineb
	RET

LCDiwait:
	PUSH	ACC
	PUSH	BUF
	LDI		ACC,0
	LDI		BUF,0
LCDiwcyk:
	DEC		ACC
	BRNE	LCDiwcyk
	DEC		BUF
	BRNE	LCDiwcyk
	POP		BUF
	POP		ACC
	RET

LCDposchar:
	RCALL	LCDpos4
	MOV		ACC,BUF
	RCALL	LCDdata
	RET

PrintBitSymb:
	LDI		XH,HIGH(SymbMem)
	LDI		XL,LOW(SymbMem)
	ADD		XL,ACC
	LD		ACC,X
	RCALL	LeftShift
	LDS		BUF,Bits_per_symbol
	RCALL	LCDlineb
	RET

PrintHexSymb:
	LDI		XH,HIGH(SymbMem)
	LDI		XL,LOW(SymbMem)
	ADD		XL,ACC
	LD		ACC,X
	LDS		BUF,Mask_byte
	AND		ACC,BUF
	RCALL	LCDlinehex2
	RET


LCDloadCG:
	RCALL	LCDCGRAM0
	RCALL	LCDwrite8
	.db $01,$07,$0F,$0E,$1C,$1C,$1C,$1C ; 1
	RCALL	LCDwrite8
	.db $1F,$1F,$1F,$00,$00,$00,$00,$00 ; 2
	RCALL	LCDwrite8
	.db $10,$1C,$1E,$0E,$07,$07,$07,$07 ; 3
	RCALL	LCDwrite8
	.db $07,$07,$07,$07,$0E,$1E,$1C,$10 ; 4
	RCALL	LCDwrite8
	.db $00,$00,$00,$00,$00,$1F,$1F,$1F ; 5
	RCALL	LCDwrite8
	.db $1C,$1C,$1C,$0C,$0E,$07,$07,$01 ; 6
	RCALL	LCDwrite8
	.db $07,$07,$07,$07,$07,$07,$07,$07 ; 7
	RCALL	LCDwrite8
	.db $1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C ; 8
	RET

