
	.NOLIST	
	.INCLUDE "m16def.inc"
	.LIST	
	
	.INCLUDE "QAM_MemoryMap.inc.asm"	
					 
	.CSEG	        ;kdov segment

	.ORG $000
	RJMP 	START
	.ORG $002
	PUSH	BUF2
	PUSH	ACC
	PUSH	BUF
	IN		BUF,SREG
	PUSH	BUF
	LDS		BUF,Period
	INC		INTREG
	CP		INTREG,BUF
	BREQ	EXT_INT
RETURN:
	POP		BUF
	OUT		SREG,BUF
	POP		BUF
	POP		ACC
	POP		BUF2
	RETI

	.ORG $026
	PUSH	ACC
	IN		ACC,SREG
	PUSH	ACC
	DEC		BS_DIV
	BRNE	TimRet
	LDS		BS_DIV,Period
	DEC		BS_CNT
	BRNE	Send_Ret
	RCALL	StopSerialSending
Send_Ret:
	CBI		PORTA,SYNCS
	RCALL	BitSend
TimRet:
	POP		ACC
	OUT		SREG,ACC
	POP		ACC
	RETI

EXT_INT:
	LDI		INTREG,$0
PutSamples:
	RCALL	DACout
	RCALL	StartSerialSending
	LDS		BUF,Symbols
	LDS		ACC,Actual_symbol
	INC		ACC
	CP		ACC,BUF
	BRNE	TestForSync
	CPI		ACC,$1
	BREQ	SetSync_clr_act
	LDI		ACC,$0
;	SBI		PORTA,SYNCS
TestForSync:
	STS		Actual_symbol,ACC
	CPI		ACC,$1
	BREQ	SetSync
;	CPI		ACC,$2
;	BRNE	LoadSymbols
;ClrSync:
;	CBI		PORTA,SYNCS
	RJMP	LoadSymbols
SetSync_clr_act:
	LDI		ACC,$0
	STS		Actual_symbol,ACC
SetSync:
	SBI		PORTA,SYNCS
LoadSymbols:
	LDS		ACC,Symbols
	CPI		ACC,0
	BREQ	LoadGener
	RCALL	GetSymbolByte
	RJMP	noLoadGener
LoadGener:
	RCALL	GenerateSymb
noLoadGener:
	STS		Symbol_byte,ACC
	RCALL	GetSymbols
	RCALL	LoadToDAC
	RJMP	RETURN

BitSend:
	CLC
	ROL		SV_SM_BYTE
	BRCC	CLR_DTA
	SBI		PORTA,DATAS
	RJMP	RETI_DTA
CLR_DTA:
	CBI		PORTA,DATAS
RETI_DTA:
	RET

StartSerialSending:
	LDS		ACC,Bits_per_symbol
	MOV		BS_CNT,ACC
	DEC		BS_CNT
	BREQ	First_Last_bit
    LDI     ACC,0
    OUT     TCNT0,ACC
    LDI     ACC,10       ; nastavi zdroj signalu   
    OUT     TCCR0,ACC    ; casovace 0 na
;	LDS		ACC,Timer_const
;	OUT     OCR0,ACC     ; porovnvac hodnota (preruseni 125/s)  
    LDI     ACC,02       ; povoli preruseni od casovace0,  
    OUT     TIMSK,ACC    ; kdyz TCNT0=OCR0.

	LDS		ACC,Symbol_Byte
	RCALL	LeftShift
	MOV		SV_SM_BYTE,ACC
	RCALL	BitSend
	RET

First_Last_bit:
	LDS		ACC,Symbol_Byte
	RCALL	LeftShift
	MOV		SV_SM_BYTE,ACC
	CBI		PORTA,SYNCS
	RCALL	BitSend
	RET

StopSerialSending:
    LDI     ACC,0        ; nastavi zdroj signalu   
    OUT     TCCR0,ACC    ; casovace 0 na
    LDI     ACC,0        ; zakazat preruseni od casovace0,  
    OUT     TIMSK,ACC    ; kdyz TCNT0=OCR0.
	RET

	.INCLUDE "QAM_Preset.inc.asm"

	.INCLUDE "QAM_ModTable.inc.asm"


;********************************************************
;***************     HLAVNI PROGRAM    ******************
;********************************************************


START:
;	LDI		ACC,LOW(RAMEND)
;	OUT		SPL,ACC		;nastav SP na konec SRAM
;	LDI		ACC,HIGH(RAMEND)
;	OUT		SPH,ACC
;	LDI		ACC,01
;	STS		GenDat1,ACC
;	LDI		ACC,00
;	STS		GenDat2,ACC
;STRT:
;	RCALL GenerateSymb
;	RJMP	STRT

	.INCLUDE "QAM_InitStart.inc.asm"

ReScreen:
	RCALL	ShowScreen
	RCALL	WaitBut
SMYCKA:
	RCALL	GetBut
	LDI		BUF,0
	CP		ACC,BUF
	BREQ	SMYCKA
	CPI		ACC,1
	BREQ	Button1
	CPI		ACC,2
	BREQ	Button2
	CPI		ACC,4
	BREQ	Button3
	CPI		ACC,8
	BREQ	Button4
	CPI		ACC,16
	BREQ	Button5
	CPI		ACC,32
	BREQ	Button6
	RJMP	SMYCKA
Button1:					;plus / 1
	RCALL	BtPlus
	RJMP	ReScreen
Button2:					;minus / 0
	RCALL	BtMinus
	RJMP	ReScreen
Button3:					;left
	RCALL	CursorToLeft
	RJMP	ReScreen
Button4:					;down
	RCALL	CursorToDown
	RJMP	ReScreen
Button5:					;up
	RCALL	CursorToUp
	RJMP	ReScreen
Button6:					;right
	RCALL	CursorToRight
	RJMP	ReScreen


BtMinus:
	LDS		ACC,CursorLine
	CPI		ACC,$00
	BREQ	BM_line_0
	CPI		ACC,$01
	BREQ	BM_line_1
	LDS		ACC,CursorPos
	SUBI	ACC,4
	RJMP	MinusBit
BM_line_0:
	LDS		ACC,CursorPos
	CPI		ACC,$05
	BREQ	BtMinusPreset
	RJMP	BtMinusMod
BM_line_1:
	LDS		ACC,CursorPos
	CPI		ACC,$05
	BREQ	BtMinusSymb
	RJMP	BtMinusPPS
BtMinusMod:		RJMP	MinusMod
BtMinusPPS:		RJMP	MinusPPS
BtMinusSymb:	RJMP	MinusSymb
BtMinusPreset:	RJMP	MinusPreset


MinusBit:
 	LDI		BUF,$ff
	STS		Preset,BUF
	RCALL	GetMask
	RCALL	MaskAND
	RCALL	CursorToRight
	RET

MinusMod:
 	LDI		ACC,$ff
	STS		Preset,ACC
 	LDS		ACC,Modulation
	CPI		ACC,$02
	BREQ	MM_set_64QAM
	CPI		ACC,$04
	BREQ	MM_set_BPSK
	CPI		ACC,$08
	BREQ	MM_set_QPSK
	CPI		ACC,$16
	BREQ	MM_set_8PSK
	CPI		ACC,$32
	BREQ	MM_set_16QAM
	CPI		ACC,$64
	BREQ	MM_set_32QAM
	RET
MM_set_BPSK:	RJMP	set_BPSK
MM_set_QPSK:	RJMP	set_QPSK
MM_set_8PSK:	RJMP	set_8PSK
MM_set_16QAM:	RJMP	set_16QAM
MM_set_32QAM:	RJMP	set_32QAM
MM_set_64QAM:	RJMP	set_64QAM



MinusPPS:
; 	CLR		ACC
;	STS		Preset,ACC
 	LDS		ACC,Period
	CPI		ACC,$01
	BREQ	MiPPS_1
	DEC		ACC
	STS		Period,ACC
	RET
MiPPS_1:
	LDI		ACC,LimitPeriods
	STS		Period,ACC
	RET


MinusSymb:
 	LDI		ACC,$ff
	STS		Preset,ACC
	LDS		ACC,Symbols
	CPI		ACC,$00
	BREQ	MiSymb_1
	DEC		ACC
	STS		Symbols,ACC
	RET
MiSymb_1:
	LDI		ACC,LimitSymbols
	STS		Symbols,ACC
	RET

MinusPreset:
 	LDS		ACC,Preset
	CPI		ACC,$00
	BREQ	MiPreset_1
	CPI		ACC,$ff
	BREQ	MiPreset_1
	DEC		ACC
	STS		Preset,ACC
	RCALL	SetPreset
;	RCALL	set_noMOD
	RET
MiPreset_1:
	LDI		ACC,LimitPresets
	STS		Preset,ACC
	RCALL	SetPreset
	RET



BtPlus:
	LDS		ACC,CursorLine
	CPI		ACC,$00
	BREQ	BP_line_0
	CPI		ACC,$01
	BREQ	BP_line_1
	LDS		ACC,CursorPos
	SUBI	ACC,4
	RJMP	PlusBit
BP_line_0:
	LDS		ACC,CursorPos
	CPI		ACC,$05
	BREQ	BtPlusPreset
	RJMP	BtPlusMod
BP_line_1:
	LDS		ACC,CursorPos
	CPI		ACC,$05
	BREQ	BtPlusSymb
	RJMP	BtPlusPPS
BtPlusMod:		RJMP	PlusMod
BtPlusPPS:		RJMP	PlusPPS
BtPlusSymb:		RJMP	PlusSymb
BtPlusPreset:	RJMP	PlusPreset


PlusBit:
 	LDI		BUF,$ff
	STS		Preset,BUF
	RCALL	GetMask
	RCALL	MaskOR
	RCALL	CursorToRight
	RET

PlusMod:
 	LDI		ACC,$ff
	STS		Preset,ACC
 	LDS		ACC,Modulation
	CPI		ACC,$02
	BREQ	PL_set_QPSK
	CPI		ACC,$04
	BREQ	PL_set_8PSK
	CPI		ACC,$08
	BREQ	PL_set_16QAM
	CPI		ACC,$16
	BREQ	PL_set_32QAM
	CPI		ACC,$32
	BREQ	PL_set_64QAM
	CPI		ACC,$64
	RJMP	PL_set_BPSK
	RET
PL_set_BPSK:	RJMP	set_BPSK
PL_set_QPSK:	RJMP	set_QPSK
PL_set_8PSK:	RJMP	set_8PSK
PL_set_16QAM:	RJMP	set_16QAM
PL_set_32QAM:	RJMP	set_32QAM
PL_set_64QAM:	RJMP	set_64QAM


PlusPPS:
; 	CLR		ACC
;	STS		Preset,ACC
 	LDS		ACC,Period
	CPI		ACC,LimitPeriods
	BREQ	PlPPS_1
	INC		ACC
	STS		Period,ACC
	RET
PlPPS_1:
	LDI		ACC,1
	STS		Period,ACC
	RET

PlusSymb:
 	LDI		ACC,$ff
	STS		Preset,ACC
 	LDS		ACC,Symbols
	CPI		ACC,LimitSymbols
	BREQ	PlSymb_1
	INC		ACC
	STS		Symbols,ACC
	RET
PlSymb_1:
	LDI		ACC,0
	STS		Symbols,ACC
	RET

PlusPreset:
 	LDS		ACC,Preset
	CPI		ACC,LimitPresets
	BREQ	PlPreset_1
	INC		ACC
	STS		Preset,ACC
	RCALL	SetPreset
	RET
;	RCALL	set_noMOD
PlPreset_1:
	LDI		ACC,0
	STS		Preset,ACC
	RCALL	SetPreset
	RET



SetPreset:
	LDS		ACC,Preset
	CPI		ACC,$00
	BRNE	Setpr_1
	LDI		ACC,0
	STS		Symbols,ACC
	LDI		ACC,$64
	STS		Modulation,ACC
	RJMP	SetPreset_Modul
Setpr_1:
	DEC		ACC
	CLC
	ROL		ACC
	CLR		BUF
	LDI		ZH,HIGH(PreSetTable*2)
	LDI		ZL,LOW(PreSetTable*2)
	ADD		ZL,ACC
	ADC		ZH,BUF
	LPM		ACC,Z+
	LPM		BUF,Z
	MOV		ZL,ACC
	MOV		ZH,BUF
	LPM		ACC,Z+
	STS		Modulation,ACC
	LPM		ACC,Z+
	CPI		ACC,0
	BREQ	SetPres_noperiod
	STS		Period,ACC
SetPres_noperiod:
	LPM		ACC,Z+
	MOV		BUF,ACC
	STS		Symbols,ACC
	LDI		XH,HIGH(SymbMem)
	LDI		XL,LOW(SymbMem)
SetPreset_01:	
	LPM		ACC,Z+
	ST		X+,ACC
	DEC		BUF
	CPI		BUF,0
	BRNE	SetPreset_01
SetPreset_Modul:
 	LDS		ACC,Modulation
	CPI		ACC,$02
	BREQ	SetPres_BPSK
	CPI		ACC,$04
	BREQ	SetPres_QPSK
	CPI		ACC,$08
	BREQ	SetPres_8PSK
	CPI		ACC,$16
	BREQ	SetPres_16QAM
	CPI		ACC,$32
	BREQ	SetPres_32QAM
	CPI		ACC,$64
	BREQ	SetPres_64QAM
	RET
SetPres_BPSK:	RJMP	set_BPSK
SetPres_QPSK:	RJMP	set_QPSK
SetPres_8PSK:	RJMP	set_8PSK
SetPres_16QAM:	RJMP	set_16QAM
SetPres_32QAM:	RJMP	set_32QAM
SetPres_64QAM:	RJMP	set_64QAM


CursorToDown:
	LDS		ACC,CursorLine
	CPI		ACC,1
	BREQ	CTD_02
	LDS		BUF,Symbols
	INC		BUF
	CP		ACC,BUF
	BREQ	CTD_01
	INC		ACC
	LDS		BUF,FirstLine
	LDI		BUF2,4
	ADD		BUF,BUF2
	CP		ACC,BUF
	BRNE	CTD_01
	LDS		BUF,FirstLine
	INC		BUF
	STS		FirstLine,BUF
CTD_01:
	STS		CursorLine,ACC
	RET
CTD_02:
	LDS		BUF,Symbols
	CPI		BUF,0
	BREQ	CTD_RET
	LDI		ACC,04
	STS		CursorPos,ACC
	LDI		ACC,02
	STS		CursorLine,ACC
CTD_RET:
	RET


CursorToUp:
	LDS		ACC,CursorLine
	CPI		ACC,0
	BREQ	CTU_02
	CPI		ACC,2
	BREQ	CTU_03
CTU_Test_FR:
	LDS		BUF,FirstLine
	CP		ACC,BUF
	BRNE	CTU_01
	LDS		BUF,FirstLine
	DEC		BUF
	STS		FirstLine,BUF
CTU_01:
	DEC		ACC
	STS		CursorLine,ACC
CTU_02:
	RET
CTU_03:
	LDI		BUF,$05
	STS		CursorPos,BUF
	RJMP	CTU_Test_FR


CursorToLeft:
 	LDS		ACC,CursorPos
	LDS		BUF,CursorLine
	CPI		BUF,2
	BRLO	CTL_line_0_1
	CPI		ACC,$04
	BRNE	CTL_dec
	CPI		BUF,2
	BRNE	CTL_noline_2
	RJMP	CTL_moveTo_0F_up
CTL_noline_2:
	LDS		ACC,Bits_per_symbol
	LDI		BUF2,$03
	ADD		ACC,BUF2
	STS		CursorPos,ACC
	RCALL	CursorToUp
	RET
CTL_dec:
	DEC		ACC
	STS		CursorPos,ACC
	RET
CTL_line_0_1:
	CPI		ACC,$0F
	BREQ	CTL_moveTo_05
	LDS		BUF,CursorLine
	CPI		BUF,1
	BREQ	CTL_moveTo_0F_up
	RET
CTL_moveTo_0F_up:
	RCALL	CursorToUp
	LDI		ACC,$0F
	STS		CursorPos,ACC
	RET
CTL_moveTo_05:
	LDI		ACC,$05
	STS		CursorPos,ACC
	RET


CursorToRight:
 	LDS		ACC,CursorPos
	LDS		BUF,CursorLine
	CPI		BUF,2
	BRLO	CTR_line_0_1
	LDS		BUF,Bits_per_symbol
	LDI		BUF2,$03
	ADD		BUF,BUF2
	CP		ACC,BUF
	BRNE	CTR_inc
	LDS		BUF,CursorLine
	LDS		BUF2,Symbols
	INC		BUF2
	CP		BUF,BUF2
	BREQ	CTR_nomove
	LDI		ACC,$04
	STS		CursorPos,ACC
	RCALL	CursorToDown
CTR_nomove:
	RET
CTR_inc:
	INC		ACC
	STS		CursorPos,ACC
	RET
CTR_line_0_1:
	CPI		ACC,5
	BREQ	CTR_moveTo_0F
	LDS		BUF,CursorLine
	CPI		BUF,1
	BREQ	CTR_line_1
	LDI		ACC,$05
	RJMP	CTR_load
CTR_line_1:
	LDI		ACC,$04
CTR_load:
	STS		CursorPos,ACC
	RCALL	CursorToDown
	RET
CTR_moveTo_0F:
	LDI		ACC,$0F
	STS		CursorPos,ACC
	RET


;***************     Zobrazen na LCD    ******************



ShowScreen:
;	RCALL	LCDclr

	LDI		ACC,$0
	RCALL	LCDline
	RCALL	LCDlinewrite
	.db		"Set:",0,0
	LDS		ACC,Preset
	CPI		ACC,$ff
	BREQ	ScrXX
	RCALL	LCDlinedec2
	RJMP	ScrMOD	
ScrXX:
	RCALL	LCDlinewrite
	.db		"--",0,0
ScrMOD:
	RCALL	LCDlinewrite
	.db		" Mod:",0,0,0
	LDS		ACC,Modulation
	CPI		ACC,$01
	BREQ	ScrNoMod
	CPI		ACC,$02
	BREQ	ScrBPSK
	CPI		ACC,$04
	BREQ	ScrQPSK
	CPI		ACC,$08
	BREQ	Scr8PSK
	RCALL	LCDlinehex2
	RCALL	LCDlinewrite
	.db		"QAM",0,0,0
	RJMP	mQAM
ScrNoMOD:
	RCALL	LCDlinewrite
	.db		"---- ",0,0,0
	RJMP	mQAM
ScrBPSK:
	RCALL	LCDlinewrite
	.db		"BPSK ",0,0,0
	RJMP	mQAM
ScrQPSK:
	RCALL	LCDlinewrite
	.db		"QPSK ",0,0,0
	RJMP	mQAM
Scr8PSK:
	RCALL	LCDlinewrite
	.db		"8PSK ",0,0,0
	RJMP	mQAM
mQAM:

	LDI		ACC,$1
	RCALL	LCDline
	RCALL	LCDlinewrite
	.db		"Smb:",0,0
	LDS		ACC,Symbols
	CPI		ACC,0
	BRNE	SymbDec
	RCALL	LCDlinewrite
	.db		"--",0,0
	RJMP	No_SymbDec
SymbDec:
	RCALL	LCDlinedec2
No_SymbDec:
	RCALL	LCDlinewrite
	.db		"    Per:",0,0
	LDS		ACC,Period
	RCALL	LCDlinedec2
;	RCALL	LCDlinewrite
;	.db		"   ",0,0,0

	LDS		ACC,Symbols
	CPI		ACC,0
	BRNE	ScrNormal
	RJMP	ScrGener	
ScrNormal:
	LDI		ACC,$FF
	STS		SymbOnScreen,Acc
	LDI		ACC,$1
OPAKsymb:
	INC		ACC
	PUSH	ACC
	LDS		BUF,SymbOnScreen
	INC		BUF
	STS		SymbOnScreen,BUF
	RCALL	LCDline
	LDI		ACC,'S'
	RCALL	LCDlinedata
	LDS		ACC,SymbOnScreen
	INC		ACC
	RCALL	LCDlinedec2
	LDI		ACC,':'
	RCALL	LCDlinedata
	LDS		ACC,SymbOnScreen
	RCALL	PrintBitSymb
	LDS		BUF,Bits_per_symbol
	LDI		ACC,7
	SUB		ACC,BUF
mQAM_6count:
	CPI		ACC,0
	BREQ	mQAM_6align
	DEC		ACC
	PUSH	ACC
	LDI		ACC,' '
	RCALL	LCDlinedata
	POP		ACC
	RJMP	mQAM_6count
mQAM_6align:
	LDI		ACC,'$'
	RCALL	LCDlinedata
	LDS		ACC,SymbOnScreen
	RCALL	PrintHexSymb
	LDI		ACC,'h'
	RCALL	LCDlinedata
	LDI		ACC,' '
	RCALL	LCDlinedata
	POP		ACC
	LDS		BUF,Symbols
	INC		BUF
	CP		ACC,BUF
	BRNE	OPAKsymb
	CPI		ACC,2
	BRNE	ScrRet
	RCALL	LCDl4
	RCALL	LCDwrite
	.db		"                ",0,0
	RJMP	ScrRet
ScrGener:
	LDI		ACC,$2
	RCALL	LCDline
	RCALL	LCDwrite
	.db		" pseudonahodny  ",0,0
	LDI		ACC,$3
	RCALL	LCDline
	RCALL	LCDwrite
	.db		" generator  dat ",0,0

ScrRet:
	RCALL	LCDlineCurPos
	RET

	.INCLUDE "QAM_CoderFunctions.inc.asm"

	.INCLUDE "QAM_BUTFunctions.inc.asm"

	.INCLUDE "QAM_DACFunctions.inc.asm"

	.INCLUDE "QAM_LCDFunctions.inc.asm"
